﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Media.Capture;
using Windows.Storage;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;
using Windows.UI.Xaml.Navigation;

/*
 * Assignment 1, Daniel Jones March 2020
 */

namespace OpenStudentRegister
{
    public sealed partial class MainPage : Page
    {
        private byte[] _photo = null;
        CameraCaptureUI ccui = new CameraCaptureUI();
        public MainPage()
        {
            this.InitializeComponent();
        }

        public async void msgBox(string title, string msg)
        {
            var messageDialog = new MessageDialog(msg, title);
            await messageDialog.ShowAsync();
        }

        public bool verifyFields()
        {
            /*
             * ensure each control has a value
             * we don't really care about validating the values meet any criteria here
             * keeping things to only 2 lines each because this is trivial and uses a lot of space
             */
            if (control_firstname.Text == "")
            {
                msgBox("Invalid input", "First name required");
                control_firstname.Focus(FocusState.Programmatic); return false;
            }
            if (control_lastname.Text == "")
            {
                msgBox("Invalid input", "Last name required");
                control_lastname.Focus(FocusState.Programmatic); return false;
            }
            if (control_address.Text == "")
            {
                msgBox("Invalid input", "Address required");
                control_address.Focus(FocusState.Programmatic); return false;
            }
            if (control_email.Text == "")
            {
                msgBox("Invalid input", "Email required");
                control_email.Focus(FocusState.Programmatic); return false;
            }
            if (control_phone.Text == "")
            {
                msgBox("Invalid input", "Phone number required");
                control_phone.Focus(FocusState.Programmatic); return false;
            }
            if (control_dob.SelectedDate == null)
            {
                msgBox("Invalid input", "Date of birth required");
                control_dob.Focus(FocusState.Programmatic); return false;
            }
            if (control_doa.SelectedDate == null)
            {
                msgBox("Invalid input", "Date of appointment required");
                control_doa.Focus(FocusState.Programmatic); return false;
            }
            return true;
        }

        public void Save_Click(object sender, RoutedEventArgs e)
        {
            /* verify fields, if a field fails, return because we're done */
            if (!verifyFields()) return;
            /* create new student object */
            Student _student = new Student(control_firstname.Text, control_lastname.Text, control_address.Text,
                                           control_email.Text, control_phone.Text, control_dob.Date.Date,
                                           control_doa.Date.Date, control_subject.Text, (int)control_knowledge.Value, _photo);
            /* add student to the database */
            initializeDatabase();
        }

        public async void ReplaceImage(object sender, RoutedEventArgs e)
        {
            BitmapImage image = new BitmapImage();
            ccui.PhotoSettings.AllowCropping = true;
            ccui.PhotoSettings.MaxResolution = CameraCaptureUIMaxPhotoResolution.HighestAvailable;
            var result = await ccui.CaptureFileAsync(CameraCaptureUIMode.Photo);
            if (result == null) return;
            var stream = await result.OpenReadAsync();
            await image.SetSourceAsync(stream);
            // store it
            stream.Seek(0);
            BinaryReader reader = new BinaryReader(stream.AsStreamForRead());
            _photo = new byte[stream.Size];
            reader.Read(_photo, 0, _photo.Length);
            control_Image.Source = image;
        }

        public void ViewStudents(object sender, RoutedEventArgs e)
        {
            Frame.Navigate(typeof(ViewStudentsPage));
        }

        public static void initializeDatabase()
        {
            /*
             * create or open the database database/students.db
             * create the table if it doesn't exist
             */

        }
    }
}
